// Culture.m				
  
#import "Culture.h"
#import <simtools.h>

@implementation Culture 
 
-initFeatures: (int) nf Traits: (int) nt {

  numFeatures = nf;
  [self randomize: nt];

  return self;
}

-randomize: (int) nt {
  int i;

  for (i=0; i<numFeatures; i++) 
    if (nt==0)
      symbol[i]=0;
    else if (nt==3) 
      symbol[i]=[uniformIntRand getIntegerWithMin: -1 withMax: 1];
    else if (nt==2)
      if ([uniformIntRand getIntegerWithMin: 0 withMax: 1])
	symbol[i]=-1;
      else
	symbol[i]=1;

  return self;
}

-randomizeProb: (double) p {
  int j;
  
  for (j=0; j<numFeatures; j++)
    if ([uniformDblRand getDoubleWithMin: 0.0 withMax: 1.0] < p)
      symbol[j] = -symbol[j];
  return self;
}

-(int)getFeature: (int) f {
  return symbol[f];
}

-setFeature: (int) f to: (int) v {
  symbol[f] = v;
  return self;
}

-(double)similarityWith: (id) c {
  int sum = 0;
  int i;
  
  for (i=0; i<numFeatures; i++)
    if (symbol[i]==[c getFeature: i])
      sum = sum + 1;
    
  return (double)sum / (double)numFeatures;
}

-print {
  int i;
  
  for (i=0; i<numFeatures; i++)
    if (symbol[i]==-1)
      printf("-");
    else if (symbol[i]==0)
      printf(".");
    else if (symbol[i]==1)
      printf("+");
    else
      printf("E");
  
  return self;
}

@end

  


