// Member.m				
  
#import "Member.h"
#import <simtools.h>

@implementation OrgMember 
 
-init: (int) n Features: (int) nf {
  idLabel = n;
  numFeatures = nf;
  belief = [Culture create: [self getZone]];
  [belief initFeatures: nf Traits: 3];
  newBelief = [Culture create: [self getZone]];
  [newBelief initFeatures: nf Traits: 0];
  beliefStar = [Culture create: [self getZone]];
  [beliefStar initFeatures: nf Traits: 0];
  return self;
}

-(int) getID {
  return idLabel;
}

-(id)getBelief {
  return belief;
}

-(id)getBeliefStar {
  return beliefStar;
}

-adapt: (double) p1 to: (id) code {
  int j, cf;

  for (j=0; j<numFeatures; j++) {
    cf = [code getFeature: j];
    [newBelief setFeature: j to: [belief getFeature: j]];
    if (cf != 0)
      if ([belief getFeature: j] != cf)
	if ([uniformDblRand getDoubleWithMin: 0.0 withMax: 1.0] < p1)
	  if ([belief getFeature: j] != 0)
	    [newBelief setFeature: j to: 0];
	  else
	    [newBelief setFeature: j to: [code getFeature: j]];
  }

  return self;
}

-updateBelief {
  id temp;

  temp = newBelief;
  newBelief = belief;
  belief = temp;

  return self;
}

-completeBelief {
  int j;
 
  for (j=0; j<numFeatures; j++)
    if ([belief getFeature: j]!=0)
      [beliefStar setFeature: j to: [belief getFeature: j]];
    else if ([uniformIntRand getIntegerWithMin: 0 withMax: 1])
      [beliefStar setFeature: j to: 1];
    else
      [beliefStar setFeature: j to: -1];

  return self;
}

@end

  


